local ADDON, Addon = ...
local AbilityButton = Addon.AbilityButton

local Poncho = LibStub('Poncho-1.0')
local Slot = Addon:NewModule('SlotFrame', Poncho:NewClass('Button', ADDON..'Slot', nil, 'PetTrackerSlot'))
local NumAbilities = NUM_BATTLE_PET_ABILITIES


--[[ Startup ]]--

function Slot:OnCreate()
	self.abilities = {}
	
	for i = 1, NumAbilities do
		self.abilities[i] = AbilityButton(self)
		self.abilities[i]:SetPoint('CENTER', -64 + i * 39, -8)
	end
end

function Slot:Display(pet, target)
	if pet:Exists() then
		local name, specieName, icon, typeIcon, model = pet:GetDisplayInfo()
		local health, maxHealth, power, speed, level = pet:GetStats()
		local isDead = not pet:IsAlive()
	
		self.isDead:SetShown(isAlive)
		self.disableFrame:SetShown(isAlive)
	
		self.name:SetText(name)
		self.subName:SetText(specieName)
		self.icon:SetTexture(icon)
		self.type:SetTexture(typeIcon)
		self.model:SetDisplayInfo(model)
	
		self.health.text:SetText(format('%d/%d', health, maxHealth))
		self.health:SetMinMaxValues(0, maxHealth)
		self.health:SetValue(health)
	
		self.power:SetText(power)
		self.speed:SetText(speed)
		self.level:SetText(level)
	
		for i = 1, NumAbilities do
			local ability = pet:GetAbility(i)
			self.abilities[i]:Display(ability, target)
		end
	end
end